Create a FeaturePython object part I: Difference between revisions

From FreeCAD Documentation
mNo edit summary
(Removed Docnav.)
(43 intermediate revisions by 3 users not shown)
Line 1: Line 1:
<languages/>
<languages/>
<translate>
<translate>

{{Page in progress}}

<!--T:1-->
{{Docnav
|[[PySide]]
|[[Creating_a_FeaturePython_Box,_Part_II|Creating a FeaturePython Box, Part II]]
}}


</translate>
</translate>
Line 22: Line 14:
This encourages:
This encourages:
*Rapid prototyping of new objects and tools with custom Python classes.
*Rapid prototyping of new objects and tools with custom Python classes.
*Serialization through {{incode|App::Property}} objects, without embedding any script in the FreeCAD document file.
*Saving and restoring data (also known as serialization) through {{incode|App::Property}} objects, without embedding any script in the FreeCAD document file.
*Creative freedom to adapt FreeCAD for any task.
*Creative freedom to adapt FreeCAD for any task.


<!--T:5-->
<!--T:5-->
This page will provide you with a complete understanding of how to use FeaturePython objects and custom Python classes in FreeCAD. We're going to construct a working example of a FeaturePython custom class, identifying all the major components and gaining an intimate understanding of how everything works as we go along.
On this page we are going to construct a working example of a FeaturePython custom class, identifying all the major components and gaining an understanding of how everything works as we go along.


==How does it work?== <!--T:6-->
==How does it work?== <!--T:6-->


<!--T:7-->
<!--T:7-->
FreeCAD comes with a number of default object types for managing different kinds of geometry. Some of them have "FeaturePython" alternatives that allow for user customization with a custom Python class.
FreeCAD comes with a number of default object types for managing different kinds of geometry. Some of them have "FeaturePython" alternatives that allow for customization with a user defined Python class.


<!--T:8-->
<!--T:8-->
The custom Python class simply takes a reference to one of these objects and modifies it. For example, the Python class may add properties to the object or link it to other objects. In addition the Python class may implement certain methods to enable the object to respond to document events, making it possible to trap object property changes and document recomputes.
This custom Python class takes a reference to one of these objects and modifies it. For example, the Python class may add properties to the object or link it to other objects. In addition the Python class may implement certain methods to enable the object to respond to document events, making it possible to trap object property changes and document recomputes.


<!--T:9-->
<!--T:9-->
When working with custom classes and FeaturePython objects it is important to know that, when it comes time to save the document, only the FeaturePython object itself is serialized. The custom class and its state are not saved in the document as this would require embedding a script in a FreeCAD document file, which would pose a significant security risk.
When working with custom classes and FeaturePython objects it is important to know that the custom class and its state are not saved in the document as this would require embedding a script in a FreeCAD document file, which would pose a significant security risk. Only the FeaturePython object itself is saved (serialized). But since the script module path is stored in the document, a user need only install the custom Python class code as an importable module, following the same folder structure, to regain the lost functionality.

<!--T:10-->
A FeaturePython object ultimately exists entirely apart from its script. The inconvenience posed by not packing the script with the object in the document file is far less than the risk posed by running a file embedded with an unknown script. However, the script module path is stored in the document file. Therefore, a user need only install the custom Python class code as an importable module following the same directory structure to regain the lost functionality.


<!--T:94-->
[[#top|top]]
[[#top|top]]


Line 56: Line 46:


<!--T:14-->
<!--T:14-->
Now we need to create some files:
Now we need to create some folders and files:
*In the {{FileName|Macro}} folder create a new folder called {{FileName|fpo}}.
*In the {{FileName|Macro}} folder create a new folder called {{FileName|fpo}}.
*In the {{FileName|fpo}} folder create an empty file: {{FileName|__init__.py}}.
*In the {{FileName|fpo}} folder create an empty file: {{FileName|__init__.py}}.
Line 63: Line 53:


<!--T:16-->
<!--T:16-->
Your directory structure should look like this:
Your folder structure should look like this:


</translate>
</translate>
Line 80: Line 70:
With our module paths and files created, let's make sure FreeCAD is set up properly:
With our module paths and files created, let's make sure FreeCAD is set up properly:
*Start FreeCAD (if you haven't done so already).
*Start FreeCAD (if you haven't done so already).
*Enable [[Report view]] ({{MenuCommand|View → Panels → Report view}}).
*Enable the [[Report view]] ({{MenuCommand|View → Panels → Report view}}).
*Enable [[Python console]] ({{MenuCommand|View → Panels → Python console}}) see [[FreeCAD Scripting Basics]].
*Enable the [[Python console]] ({{MenuCommand|View → Panels → Python console}}) see [[FreeCAD Scripting Basics]].


<!--T:95-->
Finally, navigate to the {{FileName|Macro/fpo/box}} folder and open {{FileName|box.py}} in your favorite code editor.
Finally, navigate to the {{FileName|Macro/fpo/box}} folder and open {{FileName|box.py}} in your favorite code editor. We will only edit that file.


<!--T:96-->
[[#top|top]]
[[#top|top]]


Line 99: Line 91:
"""
"""
Default constructor
Default constructor
Arguments
---------
- obj: an existing document object or an object created with FreeCAD.Document.addObject('App::FeaturePython', '{name}').
"""
"""


self.Type = 'box'
self.Type = 'box'

obj.Proxy = self
obj.Proxy = self
}}
}}
Line 114: Line 102:
'''The {{incode|__init__()}} method breakdown:'''
'''The {{incode|__init__()}} method breakdown:'''


<!--T:97-->
{|class="wikitable" cellpadding="5px" width="100%"
{|class="wikitable" cellpadding="5px" width="100%"
|style="width:25%" | {{incode|def __init__(self, obj):}}
|style="width:25%" | {{incode|def __init__(self, obj):}}
|style="width:75%" | Parameters refer to the Python class itself and the FeaturePython object that it is attached to
|style="width:75%" | Parameters refer to the Python class itself and the FeaturePython object that it is attached to.
|-
|-
| {{incode|self.Type <nowiki>=</nowiki> 'box'}}
| {{incode|self.Type <nowiki>=</nowiki> 'box'}}
| String definition of the custom Python type
| String definition of the custom Python type.
|-
|-
| {{incode|obj.Proxy <nowiki>=</nowiki> self}}
| {{incode|obj.Proxy <nowiki>=</nowiki> self}}
| Stores a reference to the Python instance in the FeaturePython object
| Stores a reference to the Python instance in the FeaturePython object.
|}
|}


<!--T:25-->
<!--T:25-->
Still in the {{FileName|box.py}} file, add the following code at the top:
Add the following code at the top of the file:


</translate>
</translate>
Line 139: Line 128:
obj = App.ActiveDocument.addObject('App::FeaturePython', obj_name)
obj = App.ActiveDocument.addObject('App::FeaturePython', obj_name)


fpo = box(obj)
box(obj)


return fpo
return obj
}}
}}
<translate>
<translate>
Line 148: Line 137:
'''The {{incode|create()}} method breakdown:'''
'''The {{incode|create()}} method breakdown:'''


<!--T:98-->
{|class="wikitable" cellpadding="5px" width="100%"
{|class="wikitable" cellpadding="5px" width="100%"
|style="width:25%" | {{incode|import FreeCAD as App}}
|style="width:25%" | {{incode|import FreeCAD as App}}
|style="width:75%" | Standard import for most Python scripts, the App alias is not required
|style="width:75%" | Standard import for most Python scripts, the App alias is not required.
|-
|-
| {{incode|obj <nowiki>=</nowiki> ... addObject(...)}}
| {{incode|obj <nowiki>=</nowiki> ... addObject(...)}}
| Creates a new FreeCAD FeaturePython object with the name passed to the method. If there is no name clash, this will be the label and the name of the created object, i.e. what is visible in the model tree. Otherwise, a unique name and label will be created based on 'obj_name'.
| Creates a new FreeCAD FeaturePython object with the name passed to the method. If there is no name clash, this will be the label and the name of the created object. Otherwise, a unique name and label will be created based on 'obj_name'.
|-
|-
| {{incode|fpo <nowiki>=</nowiki> box(obj)}}
| {{incode|box(obj)}}
| Create our custom class instance and link it to the FeaturePython object.
| Creates our custom class instance.
|-
| {{incode|return obj}}
| Returns the FeaturePython object.
|}
|}


Line 162: Line 155:
The {{incode|create()}} method is not required, but it provides a nice way to encapsulate the object creation code.
The {{incode|create()}} method is not required, but it provides a nice way to encapsulate the object creation code.


<!--T:99-->
[[#top|top]]
[[#top|top]]


Line 183: Line 177:
</translate>
</translate>
{{Code|code=
{{Code|code=
box.create('my_box')
mybox = box.create('my_box')
}}
}}
<translate>
<translate>


<!--T:35-->
<!--T:35-->
[[File:Fpo_treeview.png | right]]
[[Image:Fpo_treeview.png | right]]
You should see a new object appear in the [[Tree_view|Tree view]] labelled "my_box".
You should see a new object appear in the [[Tree_view|Tree view]] labelled "my_box".


<!--T:100-->
Note that the icon is gray. FreeCAD is telling us that the object, for now at least, is not able to display anything in the [[3D_view|3D view]]. Click on the object and note what appears in the [[Property_editor|Property editor]]. There is not very much, just the name of the object. We'll add some properties later.
Note that the icon is gray. FreeCAD is telling us that the object is not able to display anything in the [[3D_view|3D view]]. Click on the object and look at its properties in the [[Property_editor|Property editor]]. There is not much there, just the name of the object.


<!--T:101-->
Also note that there is a small blue check mark next to the FeaturePython object in the Tree view. That is because when an object is created or changed it is "touched" and needs to be recomputed. Pressing the {{Button|[[Image:Std_Refresh.svg|16px]] [[Std_Refresh|Std Refresh]]}} button will accomplish this. We will add some code to automate this later.
{{Clear}}
{{Clear}}

Let's make referencing our new object a little more convenient:

</translate>
{{Code|code=
mybox = App.ActiveDocument.my_box
}}
<translate>


<!--T:37-->
<!--T:37-->
And then we should take a look at our object's attributes:
Let's look at our object's attributes:
</translate>
</translate>
{{Code|code=
{{Code|code=
Line 211: Line 200:
<translate>
<translate>


<!--T:102-->
This will return:
This will return:


</translate>
</translate>
{{Code|code=
{{Code|code=
['Content', 'Document', 'ExpressionEngine', 'InList', 'InListRecursive', 'Label', 'MemSize', 'Module', 'Name', 'OutList', 'OutListRecursive', 'PropertiesList', 'Proxy', 'State', 'TypeId', 'ViewObject', '__class__',
['Content', 'Document', 'ExpressionEngine', 'FullName', 'ID', 'InList',
...
...
'setEditorMode', 'setExpression', 'supportedProperties', 'touch']
'setPropertyStatus', 'supportedProperties', 'touch']
}}
}}
<translate>
<translate>


<!--T:38-->
<!--T:38-->
There are a lot of attributes because we're accessing the native FreeCAD FeaturePyton object created in the first line of our {{incode|create()}} method. The {{incode|Proxy}} property we added in our {{incode|__init__()}} method is there, too.
There are a lot of attributes because we're accessing the native FreeCAD FeaturePyton object created in the first line of our {{incode|create()}} method. The {{incode|Proxy}} property we added in our {{incode|__init__()}} method is there too.


<!--T:40-->
<!--T:40-->
Line 233: Line 223:
<translate>
<translate>


<!--T:103-->
This will return:
This will return:


Line 252: Line 243:
<translate>
<translate>


<!--T:104-->
This will return:
This will return:


Line 264: Line 256:


<!--T:49-->
<!--T:49-->
Now let's see if we can make our class a little more interesting, and maybe more useful.
Now let's see if we can make our class a little more interesting, and maybe more useful as well.


<!--T:105-->
[[#top|top]]
[[#top|top]]


===Adding Properties=== <!--T:51-->
===Adding properties=== <!--T:51-->


<!--T:52-->
<!--T:52-->
Properties are the lifeblood of a FeaturePython class. Fortunately, FreeCAD supports [[FeaturePython_Custom_Properties|a number of property types]] for FeaturePython classes. These properties are attached directly to the FeaturePython object and are fully serialized when the file is saved. Unless you want to serialize the data yourself, you'll need to find some way to wrangle it into a supported property type.
Properties are the lifeblood of a FeaturePython class. Fortunately, FreeCAD supports [[FeaturePython_Custom_Properties|a number of property types]] for FeaturePython classes. These properties are attached directly to the FeaturePython object and are fully serialized when the file is saved. To avoid having to serialize data yourself, it is advisable to only use these property types.


<!--T:84-->
<!--T:84-->
Adding properties is done using the {{incode|add_property()}} method. The syntax for the method is:
Adding properties is done using the {{incode|add_property()}} method. The syntax for the method is:


<!--T:106-->
<!--Do not use Code template to avoid syntax highlighting-->
<!--Do not use Code template to avoid syntax highlighting-->
</translate>
</translate>
Line 282: Line 276:


<!--T:55-->
<!--T:55-->
You can view the list of supported properties for an object by typing:
You can view the list of supported properties by typing:


</translate>
</translate>
Line 300: Line 294:


<!--T:58-->
<!--T:58-->
Note how we're using the reference to the (serializable) FeaturePython object, {{incode|obj}}, and not the (non-serializable) Python class instance, {{incode|self}}.
Note how we're using the reference to the (serializable) FeaturePython object {{incode|obj}}, and not the (non-serializable) Python class instance {{incode|self}}.


<!--T:60-->
<!--T:60-->
Once you're done, save the changes and switch back to FreeCAD. Before we can observe the changes we made to our code, we need to reload the module. This can be accomplished by restarting FreeCAD, but restarting FreeCAD every time we make a change to the code would be inconvenient. To make it easier, try the following in the Python console:
Once you're done, save the changes and switch back to FreeCAD. Before we can observe the changes made to our code, we need to reload the module. This can be accomplished by restarting FreeCAD, but restarting FreeCAD every time we edit the code would be inconvenient. To make things easier type the following in the Python console:


</translate>
</translate>
Line 313: Line 307:


<!--T:61-->
<!--T:61-->
This will reload the box module, incorporating changes you made to the {{FileName|box.py}} file, just as if you'd restarted FreeCAD. With the module reloaded, let's see what we get when we create an object:
With the module reloaded, let's see what we get when we create an object:


</translate>
</translate>
Line 322: Line 316:


<!--T:62-->
<!--T:62-->
You should see the new box object appear in the Tree view.
You should see the new box object appear in the Tree view:
*Select it and look at the Property editor. There, you should see the ''Description'' property.

*Hover over the property name on the left and the tooltip should appear with the description you provided.
<!--T:85-->
*Select it and look at the Property editor. There, you should see the 'Description' property.
*Hover over the property name at left and see the tooltip appear with the description text you provided.
*Select the field and type whatever you like. You'll notice that Python update commands are executed and displayed in the console as you type letters and the property changes.
*Select the field and type whatever you like. You'll notice that Python update commands are executed and displayed in the console as you type letters and the property changes.

<!--T:107-->
[[#top|top]]


<!--T:86-->
<!--T:86-->
Let's add some more properties that would make a custom box object really useful. Return to your source code and add the following properties to the {{incode|__init__()}} method:
Let's add some more properties. Return to your source code and add the following properties to the {{incode|__init__()}} method:


</translate>
</translate>
Line 340: Line 335:
<translate>
<translate>


<!--T:108-->
{{Clear}}
And let's also add some code to recompute the document automatically. Add the following line above the {{incode|return()}} statement in the {{incode|create()}} method :

</translate>
[[File:object_recompute_icon.png | left]]
<translate>

<!--T:63-->
Did you notice how a blue checkmark appears next to the FeaturePython object in the tree view? That is because when an object is created or changed, it is "touched" and needs to be recomputed. Pressing the {{Button|[[Image:Std_Refresh.svg|16px]] [[Std_Refresh|Std Refresh]]}} button will accomplish this.

{{Clear}}

we can also do this automatically by adding the following line at the end of the {{incode|create()}} method:


</translate>
</translate>
Line 360: Line 345:


<!--T:65-->
<!--T:65-->
'''Be careful where you recompute a FeaturePython object! Generally you should not try to recompute an object from within itself. If possible document recomputing should rather be handled by a method external to the object.'''
'''Be careful where you recompute a FeaturePython object. Recomputing should be handled by a method external to its class.'''


</translate>
</translate>
[[File:fpo_box_properties.png | right]]
[[Image:fpo_box_properties.png | right]]
<translate>
<translate>


<!--T:109-->
Now, test your changes as follows:
Now, test your changes as follows:
*Save your changes and return to FreeCAD.
*Save your changes and reload your module.
*Delete any existing objects and reload your module.
*Delete all objects in the Tree view.
*Finally, create another box object from the Python console by calling {{incode|box.create('myBox')}}.
*Create a new box object from the Python console by calling {{incode|box.create('myBox')}}.


<!--T:87-->
<!--T:87-->
Once the box is created and you've checked to make sure it's been recomputed, select the object and look at its properties. You should note two things:
Once the box is created and you've checked to make sure it has been recomputed, select the object and look at its properties. You should note two things:
*Three new properties: ''Height'', ''Length'' and ''Width''.
*A new property group: ''Dimensions''.
*A new property group: ''Dimensions''.
*Three new properties: ''Height'', ''Length'' and ''Width''.


<!--T:89-->
<!--T:89-->
Note also how the properties have units. More specifically, they take on the linear units set in the user preferences ({{MenuCommand|Edit → Preference... → General → Units}}).
Note also how the properties have units. More specifically, they have taken on the linear units set in the user preferences ({{MenuCommand|Edit → Preference... → General → Units}}).

{{Clear}}
{{Clear}}


<!--T:90-->
<!--T:90-->
No doubt you noticed that three different values were entered for the dimensions: a floating-point value ({{incode|10.0}}) and two different strings ({{incode|'10 mm'}} and {{incode|'1 cm'}}). Yet, all three values are finally converted to the unit specified in the user preferences ({{incode|mm}} in the image). The {{incode|App::PropertyLength}} type assumes floating-point values are in millimeters, string values are parsed according to the units specified. This built-in behavior makes the {{incode|App::PropertyLength}} type ideal for dimensions.
No doubt you noticed that three different values were entered for the dimensions: a floating-point value ({{incode|10.0}}) and two different strings ({{incode|'10 mm'}} and {{incode|'1 cm'}}). The {{incode|App::PropertyLength}} type assumes floating-point values are in millimeters, string values are parsed according to the units specified, and in the GUI all values are converted to the units specified in the user preferences ({{incode|mm}} in the image). This built-in behavior makes the {{incode|App::PropertyLength}} type ideal for dimensions.


<!--T:110-->
[[#top|top]]
[[#top|top]]


===Event Trapping=== <!--T:69-->
===Trapping events=== <!--T:69-->


<!--T:70-->
<!--T:70-->
The last element required for a basic FeaturePython object is event trapping. Specifically, we want to trap the {{incode|execute()}} event, which is called when the object is recomputed. There are several other document-level events that can be trapped, both in the FeaturePython object itself and in the [[ViewProvider]], which we'll cover in another section.
The last element required for a basic FeaturePython object is event trapping. A FeaturePython object can react to events with callback functions. In our case we want the object to react whenever it is recomputed. In other words we want to trap recomputes. To accomplish this we need to add a function with a specific name, {{incode|execute()}}, to the object class. There are several other events that can be trapped, both in the FeaturePython object itself and in the [[Viewprovider|ViewProvider]], which we'll cover in the [[Creating_a_FeaturePython_Box,_Part_II|next section]].

<!--T:113-->
For a complete reference of methods available to implement on FeautrePython classes, see [[FeaturePython methods]].


<!--T:92-->
<!--T:92-->
Line 406: Line 395:


<!--T:72-->
<!--T:72-->
Test the code as follows:
Test the code by again following these steps:
*Save changes and reload the box module in the FreeCAD [[Python console]].
*Save and reload the module.
*Delete any objects in the [[Tree view]]
*Delete all objects.
*Re-create the box object.
*Create a new box object.


<!--T:73-->
<!--T:73-->
Line 417: Line 406:
That's it, you now know how to build a basic, functional FeaturePython object!
That's it, you now know how to build a basic, functional FeaturePython object!


<!--T:111-->
[[#top|top]]
[[#top|top]]


Line 432: Line 422:
obj = App.ActiveDocument.addObject('App::FeaturePython', obj_name)
obj = App.ActiveDocument.addObject('App::FeaturePython', obj_name)


fpo = box(obj)
box(obj)

App.ActiveDocument.recompute()
App.ActiveDocument.recompute()


return fpo
return obj


class box():
class box():
Line 443: Line 433:
"""
"""
Default constructor
Default constructor

Arguments
---------
- obj: an existing document object or an object created with FreeCAD.Document.addObject('App::FeaturePython', '{name}').
"""
"""


Line 467: Line 453:
<translate>
<translate>


<!--T:112-->
[[#top|top]]
[[#top|top]]

<!--T:78-->
{{Docnav
|[[PySide]]
|[[Creating_a_FeaturePython_Box,_Part_II|Creating a FeaturePython Box, Part II]]
}}


</translate>
</translate>

Revision as of 14:31, 20 August 2020

Introduction

FeaturePython objects (also referred to as Scripted objects) provide the ability to extend FreeCAD with objects that integrate seamlessly into the FreeCAD framework.

This encourages:

  • Rapid prototyping of new objects and tools with custom Python classes.
  • Saving and restoring data (also known as serialization) through App::Property objects, without embedding any script in the FreeCAD document file.
  • Creative freedom to adapt FreeCAD for any task.

On this page we are going to construct a working example of a FeaturePython custom class, identifying all the major components and gaining an understanding of how everything works as we go along.

How does it work?

FreeCAD comes with a number of default object types for managing different kinds of geometry. Some of them have "FeaturePython" alternatives that allow for customization with a user defined Python class.

This custom Python class takes a reference to one of these objects and modifies it. For example, the Python class may add properties to the object or link it to other objects. In addition the Python class may implement certain methods to enable the object to respond to document events, making it possible to trap object property changes and document recomputes.

When working with custom classes and FeaturePython objects it is important to know that the custom class and its state are not saved in the document as this would require embedding a script in a FreeCAD document file, which would pose a significant security risk. Only the FeaturePython object itself is saved (serialized). But since the script module path is stored in the document, a user need only install the custom Python class code as an importable module, following the same folder structure, to regain the lost functionality.

top

Setting things up

FeaturePython Object classes need to act as importable modules in FreeCAD. That means you need to place them in a path that exists in your Python environment (or add it specifically). For the purposes of this tutorial, we're going to use the FreeCAD user Macro folder. But if you have another idea in mind, feel free to use that instead.

If you don't know where the FreeCAD Macro folder is type FreeCAD.getUserMacroDir(True) in FreeCAD's Python console:

  • On Linux it is usually /home/<username>/.FreeCAD/Macro/.
  • On Windows it is %APPDATA%\FreeCAD\Macro\, which is usually C:\Users\<username>\Appdata\Roaming\FreeCAD\Macro\.
  • On Mac OSX it is usually /Users/<username>/Library/Preferences/FreeCAD/Macro/.

Now we need to create some folders and files:

  • In the Macro folder create a new folder called fpo.
  • In the fpo folder create an empty file: __init__.py.
  • In the fpo folder, create a new folder called box.
  • In the box folder create two files: __init__.py and box.py (leave both empty for now).

Your folder structure should look like this:

Macro/
    |--> fpo/
        |--> __init__.py
        |--> box/
            |--> __init__.py
            |--> box.py

The fpo folder provides a nice place to play with new FeaturePython objects and the box folder is the module we will be working in. __init__.py tells Python that there is an importable module in the folder, and box.py will be the class file for our new FeaturePython Object.

With our module paths and files created, let's make sure FreeCAD is set up properly:

Finally, navigate to the Macro/fpo/box folder and open box.py in your favorite code editor. We will only edit that file.

top

A FeaturePython object

Let's get started by writing our class and its constructor:

class box():

    def __init__(self, obj):
        """
        Default constructor
        """

        self.Type = 'box'

        obj.Proxy = self

The __init__() method breakdown:

def __init__(self, obj): Parameters refer to the Python class itself and the FeaturePython object that it is attached to.
self.Type = 'box' String definition of the custom Python type.
obj.Proxy = self Stores a reference to the Python instance in the FeaturePython object.

Add the following code at the top of the file:

import FreeCAD as App

def create(obj_name):
    """
    Object creation method
    """

    obj = App.ActiveDocument.addObject('App::FeaturePython', obj_name)

    box(obj)

    return obj

The create() method breakdown:

import FreeCAD as App Standard import for most Python scripts, the App alias is not required.
obj = ... addObject(...) Creates a new FreeCAD FeaturePython object with the name passed to the method. If there is no name clash, this will be the label and the name of the created object. Otherwise, a unique name and label will be created based on 'obj_name'.
box(obj) Creates our custom class instance.
return obj Returns the FeaturePython object.

The create() method is not required, but it provides a nice way to encapsulate the object creation code.

top

Testing the code

Now we can test our new object. Save your code and return to FreeCAD. Make sure you have opened a new document, you can do this by pressing Ctrl+N or selecting File → New.

In the Python console type the following:

from fpo.box import box

Now we need to create our object:

mybox = box.create('my_box')

You should see a new object appear in the Tree view labelled "my_box".

Note that the icon is gray. FreeCAD is telling us that the object is not able to display anything in the 3D view. Click on the object and look at its properties in the Property editor. There is not much there, just the name of the object.

Also note that there is a small blue check mark next to the FeaturePython object in the Tree view. That is because when an object is created or changed it is "touched" and needs to be recomputed. Pressing the Std Refresh button will accomplish this. We will add some code to automate this later.

Let's look at our object's attributes:

dir(mybox)

This will return:

['Content', 'Document', 'ExpressionEngine', 'FullName', 'ID', 'InList',
...
'setPropertyStatus', 'supportedProperties', 'touch']

There are a lot of attributes because we're accessing the native FreeCAD FeaturePyton object created in the first line of our create() method. The Proxy property we added in our __init__() method is there too.

Let's inspect it with the dir() method:

dir(mybox.Proxy)

This will return:

['Type', '__class__', '__delattr__', '__dict__', '__dir__', '__doc__',
...
'__str__', '__subclasshook__', '__weakref__']

We can see our Type property. Let's check it:

mybox.Proxy.Type

This will return:

'box'

This is indeed the assigned value, so we know we're accessing the custom class through the FeaturePython object.

Now let's see if we can make our class a little more interesting, and maybe more useful as well.

top

Adding properties

Properties are the lifeblood of a FeaturePython class. Fortunately, FreeCAD supports a number of property types for FeaturePython classes. These properties are attached directly to the FeaturePython object and are fully serialized when the file is saved. To avoid having to serialize data yourself, it is advisable to only use these property types.

Adding properties is done using the add_property() method. The syntax for the method is:

add_property(type, name, section, description)

You can view the list of supported properties by typing:

mybox.supportedProperties()

Let's try adding a property to our box class. Switch to your code editor, move to the __init__() method, and at the end of the method add:

obj.addProperty('App::PropertyString', 'Description', 'Base', 'Box description').Description = ""

Note how we're using the reference to the (serializable) FeaturePython object obj, and not the (non-serializable) Python class instance self.

Once you're done, save the changes and switch back to FreeCAD. Before we can observe the changes made to our code, we need to reload the module. This can be accomplished by restarting FreeCAD, but restarting FreeCAD every time we edit the code would be inconvenient. To make things easier type the following in the Python console:

from importlib import reload
reload(box)

With the module reloaded, let's see what we get when we create an object:

box.create('box_property_test')

You should see the new box object appear in the Tree view:

  • Select it and look at the Property editor. There, you should see the Description property.
  • Hover over the property name on the left and the tooltip should appear with the description you provided.
  • Select the field and type whatever you like. You'll notice that Python update commands are executed and displayed in the console as you type letters and the property changes.

top

Let's add some more properties. Return to your source code and add the following properties to the __init__() method:

obj.addProperty('App::PropertyLength', 'Length', 'Dimensions', 'Box length').Length = 10.0
obj.addProperty('App::PropertyLength', 'Width', 'Dimensions', 'Box width').Width = '10 mm'
obj.addProperty('App::PropertyLength', 'Height', 'Dimensions', 'Box height').Height = '1 cm'

And let's also add some code to recompute the document automatically. Add the following line above the return() statement in the create() method :

App.ActiveDocument.recompute()

Be careful where you recompute a FeaturePython object. Recomputing should be handled by a method external to its class.

Now, test your changes as follows:

  • Save your changes and reload your module.
  • Delete all objects in the Tree view.
  • Create a new box object from the Python console by calling box.create('myBox').

Once the box is created and you've checked to make sure it has been recomputed, select the object and look at its properties. You should note two things:

  • A new property group: Dimensions.
  • Three new properties: Height, Length and Width.

Note also how the properties have units. More specifically, they have taken on the linear units set in the user preferences (Edit → Preference... → General → Units).

No doubt you noticed that three different values were entered for the dimensions: a floating-point value (10.0) and two different strings ('10 mm' and '1 cm'). The App::PropertyLength type assumes floating-point values are in millimeters, string values are parsed according to the units specified, and in the GUI all values are converted to the units specified in the user preferences (mm in the image). This built-in behavior makes the App::PropertyLength type ideal for dimensions.

top

Trapping events

The last element required for a basic FeaturePython object is event trapping. A FeaturePython object can react to events with callback functions. In our case we want the object to react whenever it is recomputed. In other words we want to trap recomputes. To accomplish this we need to add a function with a specific name, execute(), to the object class. There are several other events that can be trapped, both in the FeaturePython object itself and in the ViewProvider, which we'll cover in the next section.

For a complete reference of methods available to implement on FeautrePython classes, see FeaturePython methods.

Add the following after the __init__() function:

def execute(self, obj):
    """
    Called on document recompute
    """

    print('Recomputing {0:s} ({1:s})'.format(obj.Name, self.Type))

Test the code by again following these steps:

  • Save and reload the module.
  • Delete all objects.
  • Create a new box object.

You should see the printed output in the Python Console, thanks to the recompute() call we added to the create() method. Of course, the execute() method doesn't do anything here, except tell us that it was called, but it is the key to the magic of FeaturePython objects.

That's it, you now know how to build a basic, functional FeaturePython object!

top

Complete code

import FreeCAD as App

def create(obj_name):
    """
    Object creation method
    """

    obj = App.ActiveDocument.addObject('App::FeaturePython', obj_name)

    box(obj)

    App.ActiveDocument.recompute()

    return obj

class box():

    def __init__(self, obj):
        """
        Default constructor
        """

        self.Type = 'box'

        obj.Proxy = self

        obj.addProperty('App::PropertyString', 'Description', 'Base', 'Box description').Description = ""
        obj.addProperty('App::PropertyLength', 'Length', 'Dimensions', 'Box length').Length = 10.0
        obj.addProperty('App::PropertyLength', 'Width', 'Dimensions', 'Box width').Width = '10 mm'
        obj.addProperty('App::PropertyLength', 'Height', 'Dimensions', 'Box height').Height = '1 cm'

    def execute(self, obj):
        """
        Called on document recompute
        """

        print('Recomputing {0:s} ({1:s})'.format(obj.Name, self.Type))

top